// conin.c, compiler-specific code for MinGW/GCC
// add these linker options: -Wl,-e,__start -nostartfiles

#ifdef _WIN32_WINNT
# undef _WIN32_WINNT
#endif
#define _WIN32_WINNT 0x501
#define WIN32_LEAN_AND_MEAN
#define NOUSER
#define NOSERVICE
#define NOMCX
#define NOIME
#define NOKERNEL
#include <windows.h>
#include <conio.h>
#include <stdlib.h>

#ifdef __i386
  void _start(void)
#else
  void __start(void)
#endif
{
  DWORD oldMode = 0u, cntRead = 0u, ret = 0u;
  INPUT_RECORD inpRec[4u] = {0};
  HANDLE conIn = GetStdHandle(STD_INPUT_HANDLE);
  GetConsoleMode(conIn, &oldMode);
  SetConsoleMode(conIn, (oldMode & ~ENABLE_QUICK_EDIT_MODE) | ENABLE_MOUSE_INPUT | ENABLE_EXTENDED_FLAGS);

  for(;;)
  {
    if (_kbhit())
    {
      if ((ret = _getch()) == 0u || ret == 224u)
        ret = 256u + _getch();

      SetConsoleMode(conIn, oldMode | ENABLE_EXTENDED_FLAGS);
      exit(ret);
    }
    else
    {
      WaitForSingleObject(conIn, INFINITE);
      PeekConsoleInput(conIn, inpRec, 4u, &cntRead);
      for(DWORD i = 0; i < cntRead; ++i)
      {
        if(inpRec[i].EventType == MOUSE_EVENT)
        {
          ret = (DWORD)(inpRec[i].Event.MouseEvent.dwMousePosition.Y & 0x3FFFu) << 14u | (inpRec[i].Event.MouseEvent.dwMousePosition.X & 0x3FFFu);
          if (inpRec[i].Event.MouseEvent.dwButtonState == FROM_LEFT_1ST_BUTTON_PRESSED || inpRec[i].Event.MouseEvent.dwButtonState == RIGHTMOST_BUTTON_PRESSED)
            ret |= inpRec[i].Event.MouseEvent.dwButtonState << 29u;
          else if (inpRec[i].Event.MouseEvent.dwEventFlags == MOUSE_MOVED)
            ret |= 3u << 29u;
          else
          {
            FlushConsoleInputBuffer(conIn);
            continue;
          }

          FlushConsoleInputBuffer(conIn);
          SetConsoleMode(conIn, oldMode | ENABLE_EXTENDED_FLAGS);
          exit(ret);
        }
      }
    }
  }
}
